Scala Reflection Library2.13.5 < Back


# Packages

-  package root
  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package reflect
  Definition Classes
    scala
-  package api

  EXPERIMENTAL

  EXPERIMENTAL

  The Scala Reflection API (located in scala-reflect.jar).

  In Scala 2.10.0, the Scala Reflection API and its implementation have an "experimental" status. This means that the API and the docs are not complete and can be changed in binary- and source-incompatible manner in 2.10.1. This also means that the implementation has some known issues.

  The following types are the backbone of the Scala Reflection API, and serve as a good starting point for information about Scala Reflection:

  - scala.reflect.api.Symbols
  - scala.reflect.api.Types
  - scala.reflect.api.Mirrors
  - scala.reflect.api.Universe

  For more information about Scala Reflection, see the Reflection Guide

  Definition Classes
    reflect
-  trait Trees extends AnyRef

  EXPERIMENTAL

  EXPERIMENTAL

  This trait defines the node types used in Scala abstract syntax trees (AST) and operations on them.

  Trees are the basis for Scala's abstract syntax that is used to represent programs. They are also called abstract syntax trees and commonly abbreviated as ASTs.

  In Scala reflection, APIs that produce or use `Tree`s are:

  - Annotations which use trees to represent their arguments, exposed in Annotation.scalaArgs.
  - reify, a special method on scala.reflect.api.Universe that takes an expression and returns an AST which represents the expression.
  - Macros and runtime compilation with toolboxes which both use trees as their program representation medium.

  Trees are immutable, except for three fields pos, symbol, and tpe, which are assigned when a tree is typechecked to attribute it with the information gathered by the typechecker.

  ##### Examples

  The following creates an AST representing a literal 5 in Scala source code:

      Literal(Constant(5))

  The following creates an AST representing `print("Hello World")`:

      Apply(Select(Select(This(TypeName("scala")), TermName("Predef")), TermName("print")), List(Literal(Constant("Hello World"))))

  The following creates an AST from a literal 5, and then uses `showRaw` to print it in a readable format.

      import scala.reflect.runtime.universe.{ reify, showRaw }
      print( showRaw( reify{5}.tree ) )` // prints Literal(Constant(5))

  For more information about `Tree`s, see the Reflection Guide: Symbols, Trees, Types.

  Definition Classes
    api
- Alternative
- AlternativeApi
- AlternativeExtractor
- Annotated
- AnnotatedApi
- AnnotatedExtractor
- AppliedTypeTree
- AppliedTypeTreeApi
- AppliedTypeTreeExtractor
- Apply
- ApplyApi
- ApplyExtractor
- Assign
- AssignApi
- AssignExtractor
- Bind
- BindApi
- BindExtractor
- Block
- BlockApi
- BlockExtractor
- CaseDef
- CaseDefApi
- CaseDefExtractor
- ClassDef
- ClassDefApi
- ClassDefExtractor
- CompoundTypeTree
- CompoundTypeTreeApi
- CompoundTypeTreeExtractor
- DefDef
- DefDefApi
- DefDefExtractor
- DefTree
- DefTreeApi
- ExistentialTypeTree
- ExistentialTypeTreeApi
- ExistentialTypeTreeExtractor
- Function
- FunctionApi
- FunctionExtractor
- GenericApply
- GenericApplyApi
- Ident
- IdentApi
- IdentExtractor
- If
- IfApi
- IfExtractor
- ImplDef
- ImplDefApi
- Import
- ImportApi
- ImportExtractor
- ImportSelector
- ImportSelectorApi
- ImportSelectorExtractor
- LabelDef
- LabelDefApi
- LabelDefExtractor
- Literal
- LiteralApi
- LiteralExtractor
- Match
- MatchApi
- MatchExtractor
- MemberDef
- MemberDefApi
- Modifiers
- ModifiersApi
- ModifiersExtractor
- ModuleDef
- ModuleDefApi
- ModuleDefExtractor
- NameTree
- NameTreeApi
- NamedArg
- NamedArgApi
- NamedArgExtractor
- New
- NewApi
- NewExtractor
- PackageDef
- PackageDefApi
- PackageDefExtractor
- RefTree
- RefTreeApi
- RefTreeExtractor
- Return
- ReturnApi
- ReturnExtractor
- Select
- SelectApi
- SelectExtractor
- SelectFromTypeTree
- SelectFromTypeTreeApi
- SelectFromTypeTreeExtractor
- SingletonTypeTree
- SingletonTypeTreeApi
- SingletonTypeTreeExtractor
- Star
- StarApi
- StarExtractor
- Super
- SuperApi
- SuperExtractor
- SymTree
- SymTreeApi
- Template
- TemplateApi
- TemplateExtractor
- TermTree
- TermTreeApi
- This
- ThisApi
- ThisExtractor
- Throw
- ThrowApi
- ThrowExtractor
- Transformer
- Traverser
- Tree
- TreeApi
- TreeCopier
- TreeCopierOps
- Try
- TryApi
- TryExtractor
- TypTree
- TypTreeApi
- TypeApply
- TypeApplyApi
- TypeApplyExtractor
- TypeBoundsTree
- TypeBoundsTreeApi
- TypeBoundsTreeExtractor
- TypeDef
- TypeDefApi
- TypeDefExtractor
- TypeTree
- TypeTreeApi
- TypeTreeExtractor
- Typed
- TypedApi
- TypedExtractor
- UnApply
- UnApplyApi
- UnApplyExtractor
- ValDef
- ValDefApi
- ValDefExtractor
- ValOrDefDef
- ValOrDefDefApi

c

scala.reflect.api.Trees

# CaseDefExtractor

###

#### abstract class CaseDefExtractor extends AnyRef

An extractor class to create and pattern match with syntax `CaseDef(pat, guard, body)`. This AST node corresponds to the following Scala code:

`case` pat `if` guard => body

If the guard is not present, the `guard` is set to `EmptyTree`. If the body is not specified, the `body` is set to `Literal(Constant(()))`

Source
  Trees.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. CaseDefExtractor
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new CaseDefExtractor()

### Abstract Value Members

1.  abstract def apply(pat: Universe.Tree, guard: Universe.Tree, body: Universe.Tree): Universe.CaseDef
2.  abstract def unapply(caseDef: Universe.CaseDef): Option[(Universe.Tree, Universe.Tree, Universe.Tree)]

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Universe.CaseDefExtractor toany2stringadd[Universe.CaseDefExtractor] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Universe.CaseDefExtractor, B)
   Implicit
     This member is added by an implicit conversion from Universe.CaseDefExtractor toArrowAssoc[Universe.CaseDefExtractor] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
8.  def ensuring(cond: (Universe.CaseDefExtractor) => Boolean, msg: => Any): Universe.CaseDefExtractor
   Implicit
     This member is added by an implicit conversion from Universe.CaseDefExtractor toEnsuring[Universe.CaseDefExtractor] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (Universe.CaseDefExtractor) => Boolean): Universe.CaseDefExtractor
   Implicit
     This member is added by an implicit conversion from Universe.CaseDefExtractor toEnsuring[Universe.CaseDefExtractor] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: => Any): Universe.CaseDefExtractor
    Implicit
      This member is added by an implicit conversion from Universe.CaseDefExtractor toEnsuring[Universe.CaseDefExtractor] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): Universe.CaseDefExtractor
    Implicit
      This member is added by an implicit conversion from Universe.CaseDefExtractor toEnsuring[Universe.CaseDefExtractor] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
14.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
15.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Universe.CaseDefExtractor toStringFormat[Universe.CaseDefExtractor] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
16.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
17.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
18.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
19.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
21.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
22.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
23.  def toString(): String
    Definition Classes
      AnyRef → Any
24.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
25.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
26.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (Universe.CaseDefExtractor, B)
   Implicit
     This member is added by an implicit conversion from Universe.CaseDefExtractor toArrowAssoc[Universe.CaseDefExtractor] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromUniverse.CaseDefExtractor to any2stringadd[Universe.CaseDefExtractor]

### Inherited by implicit conversion StringFormat fromUniverse.CaseDefExtractor to StringFormat[Universe.CaseDefExtractor]

### Inherited by implicit conversion Ensuring fromUniverse.CaseDefExtractor to Ensuring[Universe.CaseDefExtractor]

### Inherited by implicit conversion ArrowAssoc fromUniverse.CaseDefExtractor to ArrowAssoc[Universe.CaseDefExtractor]

### Ungrouped